﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SmartImageTester
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private string m_strFilePath;
        private SmartX.SmartFile.SEARCHFILEINFOS[] m_sFoundFileList;

        private List<string> m_lstTestImagePath = new List<string>();
        private int m_iImageCount;

        private bool m_bCheckFlag;

        private void Form1_Load(object sender, EventArgs e)
        {
            smartForm1.MainForm = this;

            smartForm1.AddChildForm(smartInnerForm1);

            smartTimer1.TimeCount = long.MaxValue;
            smartTimer1.Interval = 1;

            smartForm1.Show(0);

            SmartX.SmartMessageBox.Size(300, 170);
        }

        private void btnSelectPath_Click(object sender, EventArgs e)
        {
            smartForm1.ShowDialogInnerForm(1);
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            m_sFoundFileList = SmartX.SmartFile.FileSearch(labFilePath.Text, "*.png", true);

            for (int i = 0; i < m_sFoundFileList.Length; i++)
            {
                m_lstTestImagePath.Add(m_sFoundFileList[i].strPath.Replace("\\\\", "\\") + "\\" + m_sFoundFileList[i].strFileName + "." + m_sFoundFileList[i].strFileExtension);
            }

            for (int i = 0; i < m_lstTestImagePath.Count; i++)
            {
                Bitmap imgSizeCheck = new Bitmap(m_lstTestImagePath[i]);

                if ((imgSizeCheck.Width * imgSizeCheck.Height) > 5353 || (imgSizeCheck.Width * imgSizeCheck.Height) < 400)
                {
                    smartListBox1.AddItem(m_lstTestImagePath[i] + " [이미지 크기가 확인 가능한 범위를 벗어났습니다.]");
                    m_lstTestImagePath.RemoveAt(i);
                    i--;
                    m_bCheckFlag = true;
                }
            }

            if (m_bCheckFlag == true)
            {
                SmartX.SmartMessageBox.Show("이미지 크기(가로X세로)가 400 이하, 5353이상인 이미지는 에러가 검출되지 않습니다이러한 경우 SmartImageChecker를 이용하시기 바랍니다.","이미지 크기 범위 확인");
            }

            smartTimer1.Start();
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            smartTimer1.Stop();
        }

        private void smartTimer1_Tick(object sender, EventArgs e)
        {
            labRunningTime.Text = smartTimer1.GetNowTimeFormatString(SmartX.SmartTimer.TimeConvertFormatTypes.Day_Hour_Minute_Second);

            ImageCountUp();
            smartPictureBox1.Image = new Bitmap(m_lstTestImagePath[m_iImageCount]);

            ImageCountUp();
            smartPictureBox2.Image = new Bitmap(m_lstTestImagePath[m_iImageCount]);

            ImageCountUp();
            smartPictureBox3.Image = new Bitmap(m_lstTestImagePath[m_iImageCount]);

            ImageCountUp();
            smartPictureBox4.Image = new Bitmap(m_lstTestImagePath[m_iImageCount]);
            
            ImageCountUp();
            smartPictureBox5.Image = new Bitmap(m_lstTestImagePath[m_iImageCount]);

            ImageCountUp();
            smartPictureBox6.Image = new Bitmap(m_lstTestImagePath[m_iImageCount]);

            ImageCountUp();
            smartPictureBox7.Image = new Bitmap(m_lstTestImagePath[m_iImageCount]);

            ImageCountUp();
            smartPictureBox8.Image = new Bitmap(m_lstTestImagePath[m_iImageCount]);
        }

        private void ImageCountUp()
        {
            m_iImageCount++;
            if (m_iImageCount >= m_lstTestImagePath.Count)
            {
                m_iImageCount = 0;
            }
        }

        private void btnDialogOK_Click(object sender, EventArgs e)
        {
            m_strFilePath = labFilePath.Text;

            smartForm1.Show(0);
        }

        private void SelectRadioButton(object sender, EventArgs e)
        {
            if (radSDCard.Checked == true)
            {
                labFilePath.Text = "SD Card\\Image";
            }
            else if (radFlashDisk.Checked == true)
            {
                labFilePath.Text = "Flash Disk\\Image";
            }
            else
            {
                labFilePath.Text = "하드 디스크\\Image";
            }
        }
    }
}